/*
 *   A filter class - reads a file in, puts a file out, after doing stuff...
 */

#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#define FALSE 0
#define TRUE  1

class Filter
{
public:

    void ScreamAndDie(char *S, int i = -999)
    {
        cerr << S;
        if (i!=-999) cerr << i;
        cerr << "\n";
        exit(-1);
    }

    virtual void FilterFtn(ifstream* InFile, ofstream* OutFile)
    {
          *OutFile << InFile->rdbuf();
    }

    virtual void ParseCommand(char *S)
    {
        switch (S[0])
        {
             case 'h': 
             case 'H': HelpMsg(); break; 
        }
    }

    virtual void HelpMsg()
    {
        cout << "filter <infile> <outfile> [-h]  i\n";
        cout << "This is intended as a base class - or as a null filter.\n";
        cout << "it reads in 'infile' and writes it out, unchanged, to 'outfile'.\n";
    }

public:

    void Run(int argc, char *argv[], ofstream* out = NULL)
    {

        ifstream InFile;
        ofstream OutFile;

    	while (--argc>0)
	{
            if (argc==1)
            {
                InFile.open(argv[1]);
                if (!InFile) 
                    cerr << "Unable to open " << argv[argc] << " for input\n";
            }
            else if (argc==2 && out == NULL)      // merge with following line?
            {
                OutFile.open(argv[2]);
                if (!OutFile)
                    cerr<<"Unable to open " << argv[argc] << " for output\n";
            }
            else if (argv[argc][0]=='-')
	        ParseCommand(&argv[argc][1]);
            else
                cerr<<"Unknown parameter " << argv[argc];
        }

        if (!InFile || (!OutFile&&!out))
            ScreamAndDie("Doesn't handle piped i/o yet. sorry. (-h for help)\n");
        if (out == NULL)
            FilterFtn(&InFile, &OutFile);
        else
            FilterFtn(&InFile, out);

    }
};

/*
int main (int argc, char *argv[])
{
    new Filter(argc, argv);
    return (0);
}
*/

			

