#include <stdio.h>
#include <math.h>

int dist1(int x, int y)
{
    return sqrt(x*x+y*y);	
}

int dist2(int x, int y)
{
    if (x > y)
	return x + y/3;
    else
	return y + x/3;
}

int dist3(int x, int y)
{
    if (x > y)
	return x + y*3/8;
    else
	return y + x*3/8;
}

int dist4(int x, int y)
{
    int s;

    if ((s = x + y) == 0)
	return 0;
    else
	return ((x*x+y*y)/s + s) >> 1;
}

int dist5(int range)
{
    int count = 0, sum = 0;

    while (sum < range)
    {
	count++;
	sum += count<<1;
    }	/* sum = count*count + count */
    return count;
}

int dist6(int x)
{
    int sq = 0, tot = 0;

    while (tot <= x)
	tot += 1 + (sq++<<1);		/* tot = sq*sq */
    return sq - 1;
}

int dist7(int arg)
{
    int     t;
    int     eax;
    int     bx  = 0x8000;
    int     cx  = 0x4000;
    int     ebp = 0x60000000;

    while (!(arg&ebp))
    {
        cx  >>= 1;
        ebp >>= 2;
        bx  >>= 1;
        if (!bx)
            break;
    }
    for (;;)
    {
        t = bx*bx;
        if (cx == 0 || t == arg)
            return(bx);
        else if (t < arg)
        {
            bx += cx;
            cx >>= 1;
        }
        else
        {
            bx -= cx;
            cx >>= 1;
        }
    }
}

int dist8(int v)
{
    int             i;
    unsigned int    result;
    unsigned int    tmp;
    unsigned int    low;
    unsigned int    high;

    if (v <= 1L)
        return((unsigned)v);
    low = v;
    high = 0L;
    result = 0;
    for (i = 0; i < 16; i++)
    {
        result += result;
        high = (high << 2) | ((low >>30) & 0x3);
        low <<= 2;
        tmp = result + result + 1;
        if (high >= tmp)
        {
            result++;
            high -= tmp;
        }
    }
    if (v - (result * result) >= (result - 1))
        result++;
    return(result);
}

int dist9(unsigned long x)
{
    unsigned long s1, s2;

    if (x < 2)
	return(x);
    s1 = x;
    s2 = 2;
    do
    {
        s1 >>= 1;
        s2 <<= 1;
    } while (s1 > s2);
    do
    {
        s1 = s2;
        s2 = (x / s1 + s1)>>1;
    } while (s1 > s2);
    return(s2);
}

#define RADIUS 100

main()
{
    int x, y, error;
    int range_sq;
    int range;

    x = 0;
    y = RADIUS;
    error = RADIUS - 1;
    printf("error1\terror2\terror3\terror4\terror5\terror6\terror7\terror8\terror9\n");

    srandom(1000);
    for (error = 0; error < 10000; error++)
    {
	x = random()%1000;
	y = random()%1000;
	range_sq = x*x + y*y;
	range = (int) sqrt((double) range_sq);
	printf("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n", dist1(x, y) - range,
	    dist2(x, y) - range, dist3(x, y) - range, dist4(x, y) - range,
	    dist5(range_sq) - range, dist6(range_sq) - range,
	    dist7(range_sq) - range, dist8(range_sq) - range,
	    dist9(range_sq) - range);
    }

/*    while (x <= y)
    {
	range_sq = x*x + y*y;
	range = (int) sqrt((double) range_sq);
	printf("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n", dist1(x, y) - range,
	    dist2(x, y) - range, dist3(x, y) - range, dist4(x, y) - range,
	    dist5(range_sq) - range, dist6(range_sq) - range,
	    dist7(range_sq) - range, dist8(range_sq) - range,
	    dist9(range_sq) - range);
	error -= 2*x + 1;
	if (error < 0)
	{
	    y--;
	    error += 2*y;
	}
	x++;
    }*/
}

/*

%time  cumsecs  #call  ms/call  name
28.3     0.68  10000     0.07  _dist6
26.2     1.31  10000     0.06  _dist5
9.6     1.54                  mcount
6.7     1.70  20000     0.01  .div
5.8     1.84  10001     0.01  __doprnt
4.2     1.94  20000     0.01  .rem
4.2     2.04 154659     0.00  .umul
2.9     2.11  10000     0.01  _dist8
2.5     2.17  10000     0.01  _dist7
2.1     2.22 169590     0.00  .udiv
1.7     2.26      1    40.00  _main
1.2     2.29     26     1.15  _write
0.8     2.31 125443     0.00  .urem
0.8     2.33  10000     0.00  _dist9
0.8     2.35  20311     0.00  _perror
0.8     2.37  20310     0.00  _random
0.4     2.38  10000     0.00  _dist2
0.4     2.39  10001     0.00  _localeconv
0.4     2.40  10001     0.00  _printf
0.0     2.40     30     0.00  .mul
0.0     2.40      1     0.00  __findbuf
0.0     2.40      1     0.00  __wrtchk
0.0     2.40     26     0.00  __xflsbuf
0.0     2.40      1     0.00  _cfree
0.0     2.40  10000     0.00  _dist1
0.0     2.40  10000     0.00  _dist3
0.0     2.40  10000     0.00  _dist4
0.0     2.40      1     0.00  _exit
0.0     2.40      1     0.00  _free
0.0     2.40      1     0.00  _fstat
0.0     2.40      1     0.00  _ioctl
0.0     2.40      1     0.00  _isatty
0.0     2.40      4     0.00  _malloc
0.0     2.40      2     0.00  _on_exit
0.0     2.40      1     0.00  _profil
0.0     2.40      1     0.00  _sbrk
0.0     2.40      1     0.00  _srandom

*/
