/*
 *   Due to the bizarre nature of C++ linkage and header files, bits
 *   and pieces have to get stuck in strange places.  (Not nearly as
 *   neat as the dynamic linking in, say, java.)  C'est la vie.  Rather
 *   than have a whole pack of extra .cc files with one or two functions
 *   in them, I'm sticking them all in here.  Purists can go and break
 *   this file up if they so desire...
 *
 *   (In fact, this could probably be considered an ostream.cc extension...)
 *
 */


/*
 *    Link related functions
 */

#include "tubular.h"
#include "link.h"
//#include "array.h"
#include "parser.h"
#include "dimer.h"

ostream& operator << (ostream &o, Link &L)
{
    o << &L;
    return o;
}

ostream& operator << (ostream &o, Link *L)
{
    if (L==NULL)
        o << " link is NULL ";
    else
    {
        o << " link name:" << L->Type->Name << " to " << ((L->to==NULL)?-1:L->to->TagNo) << " pos: ";
        o << L->true_pos << " loc_pos " << L->Type->pos ; 
        o << " dirtn: " << L->Type->dirtn << "\n";
        o << " binds: " << (hex) <<  L->Type->BindsTo << " id: " << (hex) << L->Type->TypeIdHigh << " + " << L->Type->TypeId << (dec) << "\n";
    }
    return o; 
}


/*
 *   Array printing stuff.
 *
 *   Not very high quality, but we're only using it for debugging :-)
 */


/*
ostream& operator << (ostream &o, CBArray &A)
{
     for (int i=0; i<A.size; i++)
         o << " "<<i<<" " << A.base[i];
     return o;
}

ostream& operator << (ostream &o, CBArray *A)
{
    if (A==NULL)
        o << " NULL ARRAY ";
    else
        o << (*A);
    return o;
}
*/

ostream& operator << (ostream &o, ShortString &S)
{
    return o << &S;
}

ostream& operator << (ostream &o, ShortString *S)
{
    if (S==NULL) 
        return o << " Null Text ";
    else
        return o << S->text;
}

istream& operator >> (istream &i, ShortString &S)
{
    i >>  ShortString::InputBuffer;
    S = ShortString::InputBuffer;
    return i;
}

istream& operator >> (istream &i, ShortString *S)
{
    return i >> *S;
}

