#include "tubular.h"

#include "pt.h"
#include "matrix.h"

/*
 *  Takes a point and rotates it around an axis A 
 *  (passing through (0,0,0)) by an angle a in radians.
 */

void  pt::Rotate (pt Axis, double radians)
{
    *this = (CBMatrix::RotationMatrix(Axis,radians)*this);
}

/*
 *   pt related functions:
 */ 

istream& operator >> (istream &i, pt &p)
{
    i >> p.x >> p.y >> p.z;
    return i;
}

ostream& operator << (ostream &o, pt &p)
{   
    if (p.x<0.0001 && p.x>-0.0001) p.x = 0;
    if (p.y<0.0001 && p.y>-0.0001) p.y = 0;
    if (p.z<0.0001 && p.z>-0.0001) p.z = 0;
    o<<"<"<<p.x<<","<<p.y<<","<<p.z<<"> ";
   
    return o;
}
 
ostream& operator << (ostream &o, pt *p)
{
    if (p==NULL)
        o << "<NULL>";
    else 
        o << "*"<<(*p);
    return o;
}
