
/*
 *   A parser class - reads a file in, and extracts yummy useful info...
 */

#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#define FALSE 0
#define TRUE  1

class ShortString  // Quickly reinvent the wheel.  (I want *my* wheel, dammit!)
{
public:

    char text[40]; 
   
    ShortString() {text = NULL;}
    ShortString(char *Text) {strcpy(text,Text);}
    
    ShortString operator= (const char *Text)        {strcpy(text,Text); return this;}
    ShortString operator= (const ShortString Text)  {strcpy(text,Text.text); return this;}
    ShortString operator= (const ShortString *Text) {strcpy(text,Text->text); return this;}

    ShortString operator+ (const char *Text)        {strcat(text,Text); return this;}
    ShortString operator+ (const ShortString Text)  {strcat(text,Text.text); return this;}
    ShortString operator+ (const ShortString *Text) {strcat(text,Text->text); return this;}

    int operator== (const char *Text)               {return !(strcmp(text,Text.text);}
    int operator== (const ShortString Text)         {return !(strcmp(text,Text.text);}
    int operator== (const ShortString *Text)        {return !(strcmp(text,Text.text);}

    char* operator() () {return text;}
}

ostream& operator << (ostream &o, ShortString &S)
{
    o << S.text; return o;
}

ostream& operator << (ostream &o, ShortString *S)
{
    o << *S; return o;
}

istream& operator >> (istream &i, ShortString &S)
{
    return o >> S.text;
}


class Filter
{
public:

    void ScreamAndDie(char *S, int i = -999)
    {
        cerr << S;
        if (i!=-999) cerr << i;
        cerr << "\n";
        exit((i==-999)?-1:i);
    }

    virtual void Parse(ifstream* InFile)
    {
          
    }

    virtual void ParseCommand(char *S)
    {
        switch (S[0])
        {
             case 'h': 
             case 'H': HelpMsg(); break; 
        }
    }

    virtual void HelpMsg()
    {
        cout << "parse <infile> [-h]  i\n";
        cout << "This is intended as a base class - or as a null parser.\n";
        cout << "it reads in 'infile' and runs Parse()"; 
    }

public:

    void Run(int argc, char *argv[], ostream out = NULL)
    {
        ifstream InFile    ;
        ofstream OutFile   ;
        int OverWriteInput = FALSE;
        int OutStreamOpened = FALSE;

    	while (--argc>0)
	{
            if (argv[argc][0]=='-')
	        ParseCommand(&argv[argc][1]);
            else if (argc==1)
            {
                InFile.open(argv[1]);
                if (!InFile) 
                    ScreamAndDie(strcat("Unable to open input file ",argv[argc]));
            }
            else if (argc==2 && out == NULL)      // merge with following line?
            {
                if (strcmp(argv[1],argv[2])==0)       
                {
                    OverWriteInput = TRUE;
                    OutFile.open("dos2unix.temp");
                }
                else 
                    OutFile.open(argv[2]);

                if (!OutFile)
                    ScreamAndDie(strcat("Unable to open output file ",argv[argc]));
                else
                    OutStreamOpened = TRUE;
            }
            else
                cerr<<"Unknown parameter " << argv[argc];
        }

        if (!InFile)
            ScreamAndDie("Doesn't handle piped input yet. sorry. (-h for help)\n");
       if (out != NULL)
            FilterFtn(&InFile, &out);
       else if (!OutStreamOpened) 
            FilterFtn(&InFile, &cout);
       else
            FilterFtn(&InFile, &OutFile);

  
        if (OverWriteInput)
        {
            system(strcat("mv dos2unix.temp ",argv[1]));
        }


    }

};

/*
int main (int argc, char *argv[])
{
    new Filter(argc, argv);
    return (0);
}
*/

			

