#ifndef SURF
#define SURF

#define BACKGROUND 0xFFFFFFFF

#include "tubular.h"
#include "dimer.h"

#define HEADER "#include \"colors.inc\"\n#include \"shapes.inc\"\n#include \"textures.inc\""
#define CAMERA "\ncamera {\n  location <0, 0, 10>\n  look_at <0,0,0>\n}"
#define POVBACKGROUND "\nbackground {colour rgb<1,1,1> }\n"
#define LIGHTS "light_source { <0, 100, 1000> color rgb <1,1,1>}"
#define TWOPI 6.28318
#define TEXTURE "default { texture { finish {phong 0.9 phong_size 60 metallic}}}"
#define START " "

class Surf
{

public:

    static void DrawSphere(pt P, float R);
    static int  view();
    static void displayScene(long xorigin, long yorigin, long xsize, long ysize, TubParser *Parser);
    static int  CheckUserInput();
    static void InitWindow(int width, int height, int FieldSize, TubParser* Parser);
    static void SetUpColours(TubParser *Parser);
    static void CloseWindow();
    static void WriteHelp();
    static void Write_next_rgb_file();
    static void Write_next_pov_file();
    static void Write_pov_file(ofstream* F);
    static void Write_pov_colour(ofstream* F, int Colour);
    static void Write_pov_header(ofstream* F);
    static void Write_pov_sphere(ofstream* F, pt C, int Colour, float Radius = 2, char* Finish = NULL);
    static void Write_pov_link(ofstream* F, pt pos, pt dir, int Colour, char* Finish = NULL);
    //static void Write_pov_diblob(ofstream *F, pt A, pt B, int ColourA, int ColourB);
    static void Write_pov_diblob(ofstream *F, Dimer *D, int ColourA, int ColourB);
    static void WriteCurrentTexture(ofstream* F, int Colour, char* Finish);
    static void WriteTurbidity(int Step);
    static void WriteFrequencyCount(int Step);
};

#endif
