#ifndef TUBULAR
#define TUBULAR

#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

//#include "/arnie0/cbetts/tubular/math.h"  // my workstation wierdness only

#include "assert.h"
#include "hashdefines.h"


#ifndef NOSGI
#include "sgi.h"  
#include "math.h"
#include <values.h>
#include <device.h>
#else
#include <math.h>
#endif

#include "pt.h"
/*
 *  Acknowledgement:
 *     Thanks to Professor Chris Wallace for the fast gaussian
 *  random number generator used by this program, FastNorm.c.
 */
#include "FastNorm.h"

#define exit(x) abort()

//Go Faster Stripes  (undefine to make go faster :-) )
//#define SAFE


class Program
{
public:
    int   collision_test;
    int   collision_test_moving;
    int   number_of_dimers; 
    int   field_size;
    int   int_half_field_size;
    float   half_field_size;
    float half_field_size_sq; 
    int   freeze_mts;
    int   width;    
    int   height;  
    int   cycle_length;
    int   povrayfreq;
    int   tubrepfreq;  
    int   timescaleoveride;
    int   rgbfreq;    
    float molarity;  
    int   silent;   
    int   verbose;
    int   TestSequence;
    float TimeScale;
    int   NoGraphics;
    int   NoRotation;
    int   ParseOnly;
    int   NoMerge;
    int   NoMultLinkBreakage;

    float SqrtArray[10000];  //Clumsy, but fast way of getting sqrt() :-)
 
    float Viscosity;
    float Temperature;
 
    long  iterations; 
    long  NoCyclesCompleted; 
    char *PDDFString;
    char *StructureString;


    Program();
    int Run(int argc, char *argv[]); 

    pt   BoundsOffset(pt testpt);
    int  OutOfBounds(pt testpt);
    pt   MoveIntoBounds(pt testpt);
    int  EqualWithWrap(pt A, pt B);

    float fastsqrt(int X) {return (X>0&&X<10000)?SqrtArray[X]:-1;};
    float fastsqrt(float X) {return (X>0&&X<10000)?SqrtArray[(int)X]:-1;};
    float FastishSqrt(float X);

    pt RandomNormalPt() 
    {
        pt NormPt(FastGauss, FastGauss, FastGauss);
        return NormPt;
    }

private:

    void PrintVersion();
    void OutputSummary();
    void PrintHelp(char *topic);
    void PrintParserHelp();
    void PrintGraphicsHelp();
    int  ParseCommandLine(int argc, char *argv[]);
    int  CycleSim();
    int  RunTestSequence();
    void LogDataRun();
    int  SanityCheck();
    int  CheckFieldSize(int field_size);
    int  OffsetCoOrd(float X);
    void OpenStream(ofstream* o, char* fileName, int modifier, int timestamp);
    void CloseStream(ofstream* o, int timestamp);
    void OpenLogs(int modifier, int timestamp);
    void CloseLogs(int timestamp);
    void CloseAndReopenLogs();
};


#define DATALOG1 data_files  // part of some cunning plan to switch with cout at times? 
                             //  Not sure why I'm doing this... :-)
extern ofstream DATALOG1;
extern ofstream DATALOG2;
extern ofstream DATALOG3;
extern ofstream DATALOG4;
extern ofstream DATALOG5;

#define ERRORLOG error_file
extern ofstream ERRORLOG;

extern Program TheProgram;
#endif
